//	Roast+ License

#ifndef __SFJP_ROAST_EX__graphics__directx__dx10__common_HPP__
#define __SFJP_ROAST_EX__graphics__directx__dx10__common_HPP__

//#include "roast/graphics/directx/common.hpp"

#include <windows.h>
#include <tchar.h>
#include <d3d10.h>
#include <d3dx10.h>
#include <dxerr.h>

#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d10.lib")
#if _DEBUG
 #pragma comment(lib, "d3dx10d.lib")
#else
 #pragma comment(lib, "d3dx10.lib")
#endif

#include "roast/graphics/directx/common.hpp"

namespace roast
{
	namespace directx
	{
		namespace dx10
		{
			///////////////////////////////////////////////////////////////////////////

			typedef ::ID3D10Device idirect3d_device;
			typedef ::ID3D10Texture2D idirect3d_texture;
			typedef ::ID3D10Buffer idirect3d_vertex_buffer;
			//typedef ::IDirect3DTexture10 dx_display_mode_struct;
			typedef ::D3DFORMAT d3dformat_t;
			typedef ::ID3D10Buffer d3dvertexbuffer, d3dbuffer;
			typedef ::ID3D10Effect d3deffect;
			typedef ::ID3D10EffectTechnique d3dtechnique;
			typedef ::ID3D10EffectPass d3dpass;
			typedef ::ID3D10Blob d3dblob;
			typedef ::ID3D10InputLayout d3dinputlayout;
			
			///////////////////////////////////////////////////////////////////////////

			namespace graphics
			{
				using namespace ::roast::directx::graphics;

				typedef ::roast::directx::dx10::idirect3d_device idevice;
				typedef ::roast::directx::dx10::idirect3d_texture itexture;
			}

			namespace exception_code_root
			{
				enum _
				{
					first=		0x10000000,
					device=		0x10001000,
					buffer=		0x10002000,
					shader=		0x10003000,
					effect=		0x10003400,
					technique=	0x10003600,
					pass=		0x10003700,
					___tail
				};
			}
		}
	}
}

#endif//__SFJP_ROAST_EX__graphics__directx__dx10__common_HPP__
