//	Roast+ License

#ifndef __SFJP_ROAST_EX__graphics__directx__dx9__common_HPP__
#define __SFJP_ROAST_EX__graphics__directx__dx9__common_HPP__

//#include "roast/graphics/directx/common.hpp"

#include <D3d9.h>
#include <D3dx9core.h>
#include <D3dx9effect.h>
#pragma comment(lib, "D3d9.lib")
#pragma comment(lib, "D3dx9.lib")

#include "roast/graphics/directx/common.hpp"

namespace roast
{
	namespace directx
	{
		namespace dx9
		{
			///////////////////////////////////////////////////////////////////////////

			typedef ::IDirect3D9 idirect3d;
			typedef ::IDirect3DDevice9 idirect3d_device;
			typedef ::IDirect3DSurface9 idirect3d_surface;
			typedef ::IDirect3DTexture9 idirect3d_texture;
			//typedef ::IDirect3DTexture9 dx_display_mode_struct;
			typedef ::D3DFORMAT d3dformat_t;
			typedef ::IDirect3DVertexBuffer9 d3dvertexbuffer;
			typedef ::ID3DXEffect d3deffect;
			
			///////////////////////////////////////////////////////////////////////////

			namespace graphics
			{
				using namespace ::roast::directx::graphics;

				typedef ::IDirect3DDevice9 idevice;
				typedef ::IDirect3DSurface9 isurface;
				typedef ::IDirect3DTexture9 itexture;
			}

			namespace exception_code_root
			{
				enum _
				{
					first=		0x10000000,
					device=		0x10000020,
					buffer=		0x10002000,
					shader=		0x10003000,
					effect=		0x10003400,
					technique=	0x10003600,
					pass=		0x10003700,
					___tail
				};
			}
		}
	}
}

#endif//__SFJP_ROAST_EX__graphics__directx__dx9__common_HPP__
