//	Roast+ License

#ifndef __SFJP_ROAST_EX__graphics__directx__shader_param_HPP__
#define __SFJP_ROAST_EX__graphics__directx__shader_param_HPP__

#include "roast/graphics/directx/tuple_ul.hpp"

namespace roast
{
	namespace directx
	{
		namespace graphics
		{
			//////////////////////////////////////////////////////
			
			namespace shader_param_type
			{
				//enum shader_param_type
				enum _
				{
					float1,
					float2,
					float3,
					float4,
					float4x4,

					d3dvector2,
					d3dvector3,
					d3dvector4,

					vector_rgb,
					vector_rgba,

					bool_,
					int_,
					uint,
					half,
					double_,

					_null
				};

				template <::roast::directx::graphics::shader_param_type::_ e>
				struct to_type{ typedef _internal::null_type type; };

				template<> struct to_type<float1>{ typedef float type; };
				template<> struct to_type<float2>{ typedef float type[2]; };
				template<> struct to_type<float3>{ typedef float type[3]; };
				template<> struct to_type<float4>{ typedef float type[4]; };

				template<> struct to_type<d3dvector2>{ typedef ::D3DXVECTOR2 type; };
				template<> struct to_type<d3dvector3>{ typedef ::D3DXVECTOR3 type; };
				template<> struct to_type<d3dvector4>{ typedef ::D3DXVECTOR4 type; };

				template<> struct to_type<vector_rgb>{ typedef ::roast::directx::graphics::vector_rgb type; };
				template<> struct to_type<vector_rgba>{ typedef ::roast::directx::graphics::vector_rgba type; };

				template<> struct to_type<bool_>{ typedef bool type; };
				template<> struct to_type<int_>{ typedef int type; };
				template<> struct to_type<uint>{ typedef unsigned int type; };
				template<> struct to_type<double_>{ typedef double type; };
			}
			typedef shader_param_type::_ shader_param_type_e;
			
			///////////////////

			///////////////////
			
			template <shader_param_type_e T1,
				shader_param_type_e T2=shader_param_type::_null,
				shader_param_type_e T3=shader_param_type::_null,
				shader_param_type_e T4=shader_param_type::_null,
				shader_param_type_e T5=shader_param_type::_null,
				shader_param_type_e T6=shader_param_type::_null,
				shader_param_type_e T7=shader_param_type::_null,
				shader_param_type_e T8=shader_param_type::_null,
				shader_param_type_e T9=shader_param_type::_null,
				shader_param_type_e T10=shader_param_type::_null,
				shader_param_type_e T11=shader_param_type::_null,
				shader_param_type_e T12=shader_param_type::_null,
				shader_param_type_e T13=shader_param_type::_null,
				shader_param_type_e T14=shader_param_type::_null,
				shader_param_type_e T15=shader_param_type::_null,
				shader_param_type_e T16=shader_param_type::_null,
				shader_param_type_e T17=shader_param_type::_null,
				shader_param_type_e T18=shader_param_type::_null,
				shader_param_type_e T19=shader_param_type::_null,
				shader_param_type_e T20=shader_param_type::_null,
				shader_param_type_e T21=shader_param_type::_null,
				shader_param_type_e T22=shader_param_type::_null,
				shader_param_type_e T23=shader_param_type::_null,
				shader_param_type_e T24=shader_param_type::_null,
				shader_param_type_e T25=shader_param_type::_null,
				shader_param_type_e T26=shader_param_type::_null,
				shader_param_type_e T27=shader_param_type::_null,
				shader_param_type_e T28=shader_param_type::_null,
				shader_param_type_e T29=shader_param_type::_null,
				shader_param_type_e T30=shader_param_type::_null,
				shader_param_type_e T31=shader_param_type::_null,
				shader_param_type_e T32=shader_param_type::_null>
			struct shader_param_ : public _internal::tuple<
				typename shader_param_type::to_type<T1>::type,				
				typename shader_param_type::to_type<T2>::type,
				typename shader_param_type::to_type<T3>::type,
				typename shader_param_type::to_type<T4>::type,
				typename shader_param_type::to_type<T5>::type,
				typename shader_param_type::to_type<T6>::type,
				typename shader_param_type::to_type<T7>::type,
				typename shader_param_type::to_type<T8>::type,
				typename shader_param_type::to_type<T9>::type,
				typename shader_param_type::to_type<T10>::type,
				typename shader_param_type::to_type<T11>::type,
				typename shader_param_type::to_type<T12>::type,
				typename shader_param_type::to_type<T13>::type,
				typename shader_param_type::to_type<T14>::type,
				typename shader_param_type::to_type<T15>::type,
				typename shader_param_type::to_type<T16>::type,
				typename shader_param_type::to_type<T17>::type,
				typename shader_param_type::to_type<T18>::type,
				typename shader_param_type::to_type<T19>::type,
				typename shader_param_type::to_type<T20>::type,
				typename shader_param_type::to_type<T21>::type,
				typename shader_param_type::to_type<T22>::type,
				typename shader_param_type::to_type<T23>::type,
				typename shader_param_type::to_type<T24>::type,
				typename shader_param_type::to_type<T25>::type,
				typename shader_param_type::to_type<T26>::type,
				typename shader_param_type::to_type<T27>::type,
				typename shader_param_type::to_type<T28>::type,
				typename shader_param_type::to_type<T29>::type,
				typename shader_param_type::to_type<T30>::type,
				typename shader_param_type::to_type<T31>::type,
				typename shader_param_type::to_type<T32>::type
			> {
				//typename to_type<T1>::type v1;
			};
			
			//////////////////////////////////////////////////////
		}
	}
}

#endif//__SFJP_ROAST_EX__graphics__directx__shader_param_HPP__
