#include "roast/graphics/directx/dx9.hpp"
#include "roast/windows/window.hpp"
#include <stdio.h>

using namespace ::roast::directx::dx9;

void ___( void )
{
	try
	{
		graphics::first f;
		graphics::first f2(f);
		graphics::first f3;
		//f.get_device_caps(0,(D3DDEVTYPE)0);
		printf("graphics::first Construct... OK\n");

		//////////////

		if ( f.test_device(0, D3DDEVTYPE_HAL) )
			printf("graphics::first::test_device(): D3DDEVTYPE_HAL Supported.\n");
		else
			printf("graphics::first::test_device(): D3DDEVTYPE_HAL Not Supported.\n");

		if ( f.test_device(0, D3DDEVTYPE_REF) )
			printf("graphics::first::test_device(): D3DDEVTYPE_REF Supported.\n");
		else
			printf("graphics::first::test_device(): D3DDEVTYPE_REF Not Supported.\n");

		if ( f.test_device(0, D3DDEVTYPE_SW) )
			printf("graphics::first::test_device(): D3DDEVTYPE_SW Supported.\n");
		else
			printf("graphics::first::test_device(): D3DDEVTYPE_SW Not Supported.\n");

		//////////////

		graphics::disp_mode dm = f.get_adapter_display_mode();
		printf("\n=== Current Display Mode ===\n");
		printf("Width=%d\n", dm.get_width());
		printf("Height=%d\n", dm.get_height());
		printf("RefreshRate=%d\n", dm.get_refresh_rate());

		/////////////////////////////////////////////////////////////////////////////////////

		::roast::windows::window w("Test");
		w.start(NULL,NULL,"hoge",200,400);

		D3DPRESENT_PARAMETERS pp;
		pp.hDeviceWindow = w.get_hwnd();
		pp.Windowed = TRUE;
		::roast::directx::device_mode::auto_;
		//graphics::device d(f, ::roast::directx::device_mode::auto_, w.get_hwnd(), 0, &pp);
	}
	catch( ::std::string &s )
	{
		printf("\n######################################################################\n");
		printf("%s\n", s.c_str() );
	}
}
